-- Cg.e
-- /Mic, 2008

include machine.e
include dll.e


global constant CG_VERSION_NUM 		= 1502

global constant
	CG_GL_MATRIX_IDENTITY 		= 0,
	CG_GL_MATRIX_TRANSPOSE 		= 1,
	CG_GL_MATRIX_INVERSE 		= 2,
	CG_GL_MATRIX_INVERSE_TRANSPOSE 	= 3,
	CG_GL_MODELVIEW_MATRIX 		= 4,
	CG_GL_PROJECTION_MATRIX 	= 5,
	CG_GL_TEXTURE_MATRIX 		= 6,
	CG_GL_MODELVIEW_PROJECTION_MATRIX = 7,
	CG_GL_VERTEX 			= 8,
	CG_GL_FRAGMENT 			= 9,
	CG_GL_GEOMETRY 			= 10

global constant
	 CG_PARAMETERCLASS_UNKNOWN 	= 0,
	 CG_PARAMETERCLASS_SCALAR 	= 1,
	 CG_PARAMETERCLASS_VECTOR 	= 2,
	 CG_PARAMETERCLASS_MATRIX 	= 3,
	 CG_PARAMETERCLASS_STRUCT 	= 4,
	 CG_PARAMETERCLASS_ARRAY 	= 5,
	 CG_PARAMETERCLASS_SAMPLER 	= 6,
	 CG_PARAMETERCLASS_OBJECT 	= 7

global constant
    	CG_UNKNOWN_DOMAIN 		= 0,
    	CG_FIRST_DOMAIN   		= 1,
    	CG_VERTEX_DOMAIN  		= 1,
    	CG_FRAGMENT_DOMAIN 		= 2,
    	CG_GEOMETRY_DOMAIN 		= 3,
    	CG_NUMBER_OF_DOMAINS 		= 4

global constant
    	CG_MAP_READ 			= 0,
    	CG_MAP_WRITE			= 1,
    	CG_MAP_READ_WRITE		= 2,
    	CG_MAP_WRITE_DISCARD		= 3,
    	CG_MAP_WRITE_NO_OVERWRITE	= 4


global constant
    	CG_BUFFER_USAGE_STREAM_DRAW 	= 0,
    	CG_BUFFER_USAGE_STREAM_READ	= 1,
    	CG_BUFFER_USAGE_STREAM_COPY	= 2,
    	CG_BUFFER_USAGE_STATIC_DRAW	= 3,
    	CG_BUFFER_USAGE_STATIC_READ	= 4,
    	CG_BUFFER_USAGE_STATIC_COPY	= 5,
    	CG_BUFFER_USAGE_DYNAMIC_DRAW	= 6,
    	CG_BUFFER_USAGE_DYNAMIC_READ	= 7,
    	CG_BUFFER_USAGE_DYNAMIC_COPY	= 8
    
global constant
	CG_UNKNOWN 			= 4096,
	CG_IN 				= 4097,
	CG_OUT 				= 4098,
	CG_INOUT 			= 4099,
	CG_MIXED 			= 4100,
	CG_VARYING 			= 4101,
	CG_UNIFORM 			= 4102,
	CG_CONSTANT 			= 4103,
	CG_PROGRAM_SOURCE 		= 4104,
	CG_PROGRAM_ENTRY 		= 4105,
	CG_COMPILED_PROGRAM 		= 4106,
	CG_PROGRAM_PROFILE 		= 4107,
	CG_GLOBAL 			= 4108,
	CG_PROGRAM 			= 4109,
	CG_DEFAULT 			= 4110,
	CG_ERROR 			= 4111,
	CG_SOURCE 			= 4112,
	CG_OBJECT 			= 4113,
	CG_COMPILE_MANUAL 		= 4114,
	CG_COMPILE_IMMEDIATE 		= 4115,
	CG_COMPILE_LAZY 		= 4116,
	CG_CURRENT 			= 4117,
	CG_LITERAL 			= 4118,
	CG_VERSION 			= 4119,
	CG_ROW_MAJOR 			= 4120,
	CG_COLUMN_MAJOR 		= 4121,
	CG_FRAGMENT 			= 4122,
	CG_VERTEX 			= 4123,
	CG_POINT 			= 4124,
	CG_LINE 			= 4125,
	CG_LINE_ADJ 			= 4126,
	CG_TRIANGLE 			= 4127,
	CG_TRIANGLE_ADJ 		= 4128,
	CG_POINT_OUT 			= 4129,
	CG_LINE_OUT 			= 4130,
	CG_TRIANGLE_OUT 		= 4131,
	CG_IMMEDIATE_PARAMETER_SETTING 	= 4132,
	CG_DEFERRED_PARAMETER_SETTING 	= 4133,
	CG_NO_LOCKS_POLICY 		= 4134,
	CG_THREAD_SAFE_POLICY 		= 4135,
	CG_FORCE_UPPER_CASE_POLICY 	= 4136,
	CG_UNCHANGED_CASE_POLICY 	= 4137


-------------------------------------------------------------------------------------------------------------------------------------


constant cgDll = open_dll("cg.dll"),
	 cgD3D9Dll = open_dll("cgD3D9.dll"),
	 cgGLDll = open_dll("cgGL.dll")


if cgDll = NULL then
	if message_box("Missing a required dll file: cg.dll","Error",or_bits(MB_OK,MB_ICONERROR)) then end if
 	abort(1)
end if
if cgD3D9Dll = NULL then
	if message_box("Missing a required dll file: cgD3D9.dll","Error",or_bits(MB_OK,MB_ICONERROR)) then end if
 	abort(1)
end if
if cgGLDll = NULL then
	if message_box("Missing a required dll file: cgGL.dll","Error",or_bits(MB_OK,MB_ICONERROR)) then end if
 	abort(1)
end if

constant cgInternalBuffer = allocate(1024)



function cg_proc(atom lib,sequence name,sequence parms)
	integer hProc

 	hProc = define_c_proc(lib,name,parms)
 	if hProc = -1 then
  		puts(1,"Error! Can\'t find "&name&"().\nPress any key..")
  		while get_key() =-1 do
  		end while
  		abort(1)
 	end if
 	return hProc
end function


function cg_func(atom lib,sequence name,sequence parms,atom rtype)
	integer hFunc
 	
 	hFunc = define_c_func(lib,name,parms,rtype)
 	if hFunc = -1 then
  		puts(1,"Error! Can\'t find "&name&"().\nPress any key..")
  		while get_key() =-1 do
  		end while
  		abort(1)
 	end if
 	return hFunc
end function


-------------------------------------------------------------------------------------------------------------------------------------

global constant
cgCreateContextC 	= cg_func(cgDll, "+cgCreateContext", {}, C_POINTER),
cgCreateProgramFromFileC= cg_func(cgDll, "+cgCreateProgramFromFile", {C_POINTER,C_INT,C_POINTER,C_INT,C_POINTER,C_POINTER}, C_POINTER),
cgCreateProgramC	= cg_func(cgDll, "+cgCreateProgram", {C_POINTER,C_INT,C_POINTER,C_INT,C_POINTER,C_POINTER}, C_POINTER),
cgCreateObjFromFileC	= cg_func(cgDll, "+cgCreateObjFromFile", {C_POINTER,C_INT,C_POINTER,C_INT,C_POINTER}, C_POINTER),
cgCreateObjC		= cg_func(cgDll, "+cgCreateObj", {C_POINTER,C_INT,C_POINTER,C_INT,C_POINTER}, C_POINTER),
cgDestroyContextC 	= cg_proc(cgDll, "+cgDestroyContext", {C_POINTER}),
cgDestroyObjC		= cg_proc(cgDll, "+cgDestroyObj", {C_POINTER}),
cgDestroyParameterC	= cg_proc(cgDll, "+cgDestroyParameter", {C_POINTER}),
cgDestroyProgramC	= cg_proc(cgDll, "+cgDestroyProgram", {C_POINTER}),
cgGetErrorC		= cg_func(cgDll, "+cgGetError", {}, C_INT),
cgGetFirstErrorC	= cg_func(cgDll, "+cgGetFirstError", {}, C_INT),
cgGetErrorStringC	= cg_func(cgDll, "+cgGetErrorString", {C_INT}, C_POINTER),
cgGetLastErrorStringC	= cg_func(cgDll, "+cgGetLastErrorString", {C_POINTER}, C_POINTER),
cgGetStringC		= cg_func(cgDll, "+cgGetString", {C_INT}, C_POINTER),
cgSetParameterSettingModeC=cg_proc(cgDll, "+cgSetParameterSettingMode", {C_POINTER,C_INT}),
cgGetNamedParameterC	= cg_func(cgDll, "+cgGetNamedParameter", {C_POINTER, C_POINTER}, C_POINTER),
cgSetParameter1dC	= cg_proc(cgDll, "+cgSetParameter1d", {C_POINTER, C_DOUBLE}),
cgSetParameter1fC	= cg_proc(cgDll, "+cgSetParameter1f", {C_POINTER, C_FLOAT}),
cgSetParameter1iC	= cg_proc(cgDll, "+cgSetParameter1i", {C_POINTER, C_INT}),
cgSetParameter2dC	= cg_proc(cgDll, "+cgSetParameter2d", {C_POINTER, C_DOUBLE, C_DOUBLE}),
cgSetParameter2fC	= cg_proc(cgDll, "+cgSetParameter2f", {C_POINTER, C_FLOAT, C_FLOAT}),
cgSetParameter2iC	= cg_proc(cgDll, "+cgSetParameter2i", {C_POINTER, C_INT, C_INT}),
cgSetParameter3dC	= cg_proc(cgDll, "+cgSetParameter3d", {C_POINTER, C_DOUBLE, C_DOUBLE, C_DOUBLE}),
cgSetParameter3fC	= cg_proc(cgDll, "+cgSetParameter3f", {C_POINTER, C_FLOAT, C_FLOAT, C_FLOAT}),
cgSetParameter3iC	= cg_proc(cgDll, "+cgSetParameter3i", {C_POINTER, C_INT, C_INT, C_INT}),

cgD3D9BindProgramC	= cg_func(cgD3D9Dll, "+cgD3D9BindProgram", {C_POINTER}, C_UINT),
cgD3D9IsProgramLoadedC	= cg_func(cgD3D9Dll, "+cgD3D9IsProgramLoaded", {C_POINTER}, C_INT),
cgD3D9LoadProgramC	= cg_func(cgD3D9Dll, "+cgD3D9LoadProgram", {C_POINTER, C_INT, C_UINT}, C_UINT),
cgD3D9UnloadProgramC	= cg_func(cgD3D9Dll, "+cgD3D9UnloadProgram", {C_POINTER}, C_UINT),
cgD3D9GetLatestVertexProfileC	= cg_func(cgD3D9Dll, "+cgD3D9GetLatestVertexProfile", {}, C_INT),
cgD3D9GetLatestPixelProfileC	= cg_func(cgD3D9Dll, "+cgD3D9GetLatestPixelProfile", {}, C_INT),
cgD3D9GetOptimalOptionsC= cg_func(cgD3D9Dll, "+cgD3D9GetOptimalOptions", {C_INT}, C_POINTER),
cgD3D9IsProfileSupportedC	= cg_func(cgD3D9Dll, "+cgD3D9IsProfileSupported", {C_INT}, C_INT),
cgD3D9GetLastErrorC	= cg_func(cgD3D9Dll, "+cgD3D9GetLastError", {}, C_UINT),
cgD3D9SetDeviceC	= cg_func(cgD3D9Dll, "+cgD3D9SetDevice", {C_POINTER}, C_UINT),
cgD3D9SetTextureC	= cg_func(cgD3D9Dll, "+cgD3D9SetTexture", {C_POINTER, C_POINTER}, C_UINT),
cgD3D9SetTextureParameterC	= cg_func(cgD3D9Dll, "+cgD3D9SetTextureParameter", {C_POINTER, C_POINTER}, C_UINT),

cgGLBindProgramC	= cg_proc(cgGLDll, "+cgGLBindProgram", {C_POINTER}), 
cgGLDisableProfileC	= cg_proc(cgGLDll, "+cgGLDisableProfile", {C_INT}),
cgGLEnableProfileC	= cg_proc(cgGLDll, "+cgGLEnableProfile", {C_INT}),
cgGLGetLatestProfileC	= cg_func(cgGLDll, "+cgGLGetLatestProfile", {C_INT}, C_INT),
cgGLLoadProgramC	= cg_proc(cgGLDll, "+cgGLLoadProgram", {C_POINTER}),    
cgGLSetDebugModeC	= cg_proc(cgGLDll, "+cgGLSetDebugMode", {C_INT}),
cgGLSetOptimalOptionsC	= cg_proc(cgGLDll, "+cgGLSetOptimalOptions", {C_INT})


-------------------------------------------------------------------------------------------------------------------------------------

global function cgCreateContext()
	return c_func(cgCreateContextC, {})
end function


global function cgCreateObj(atom ctx, integer pgmType, sequence pgmCode, integer pfl, atom args)
	atom temp, retVal
	retVal = 0
	temp = allocate(length(pgmCode))
	if temp then
		poke(temp, pgmCode)
		retVal = c_func(cgCreateObjC, {ctx, pgmType, temp, pfl, args})
		free(temp)
	end if
	return retVal
end function


global function cgCreateObjFromFile(atom ctx, integer pgmType, sequence pgmFile, integer pfl, atom args)
	poke(cgInternalBuffer, pgmFile&0)
	return c_func(cgCreateObjFromFileC, {ctx, pgmType, cgInternalBuffer, pfl, args})
end function


global function cgCreateProgram(atom ctx, integer pgmType, sequence pgmCode, integer pfl, sequence entry, atom args)
	atom temp, retVal
	retVal = 0
	temp = allocate(length(pgmCode))
	if temp then
		poke(temp, pgmCode)
		poke(cgInternalBuffer+512, entry&0)
		retVal = c_func(cgCreateProgramC, {ctx, pgmType, temp, pfl, cgInternalBuffer+512, args})
		free(temp)
	end if
	return retVal
end function


global function cgCreateProgramFromFile(atom ctx, integer pgmType, sequence pgmFile, integer pfl, sequence entry, atom args)
	poke(cgInternalBuffer, pgmFile&0)
	poke(cgInternalBuffer+512, entry&0)
	return c_func(cgCreateProgramFromFileC, {ctx, pgmType, cgInternalBuffer, pfl, cgInternalBuffer+512, args})
end function


global procedure cgDestroyContext(atom ctx)
	c_proc(cgDestroyContextC, {ctx})
end procedure


global procedure cgDestroyObj(atom obj)
	c_proc(cgDestroyObjC, {obj})
end procedure


global procedure cgDestroyParameter(atom parm)
	c_proc(cgDestroyParameterC, {parm})
end procedure


global procedure cgDestroyProgram(atom pgm)
	c_proc(cgDestroyProgramC, {pgm})
end procedure


global function cgGetError()
	return c_func(cgGetErrorC, {})
end function


global function cgGetFirstError()
	return c_func(cgGetFirstErrorC, {})
end function


global function cgGetErrorString(integer error)
	sequence s
	atom str
	integer i
	
	str = c_func(cgGetErrorStringC, {error})
	s = ""
	i = 0
	while str and i<512 do
		if peek(str+i) then
			s &= peek(str+i)
		else
			exit
		end if
		i += 1
	end while
	
	return s
end function


global function cgGetLastErrorString()
	sequence le
	atom str
	integer i
	
	str = c_func(cgGetLastErrorStringC, {cgInternalBuffer})
	le = {peek4u(cgInternalBuffer),""}
	i = 0
	while str and i<512 do
		if peek(str+i) then
			le[2] &= peek(str+i)
		else
			exit
		end if
		i += 1
	end while
	
	return le
end function


global function cgGetString(integer sname)
	sequence s
	atom str
	integer i
	
	str = c_func(cgGetStringC, {sname})
	s = ""
	i = 0
	while str and i<512 do
		if peek(str+i) then
			s &= peek(str+i)
		else
			exit
		end if
		i += 1
	end while
	
	return s
end function

	
global procedure cgSetParameterSettingMode(atom ctx, integer psMode)
	c_proc(cgSetParameterSettingModeC, {ctx, psMode})
end procedure


global function cgGetNamedParameter(atom pgm, sequence parmName)
	poke(cgInternalBuffer, parmName&0)
	return c_func(cgGetNamedParameterC, {pgm, cgInternalBuffer})
end function


global procedure cgSetParameter1d(atom parm, atom d)
	c_proc(cgSetParameter1dC, {parm, d})
end procedure


global procedure cgSetParameter1f(atom parm, atom f)
	c_proc(cgSetParameter1fC, {parm, f})
end procedure


global procedure cgSetParameter1i(atom parm, atom i)
	c_proc(cgSetParameter1iC, {parm, i})
end procedure


global procedure cgSetParameter2d(atom parm, sequence d)
	c_proc(cgSetParameter2dC, parm&d)
end procedure


global procedure cgSetParameter2f(atom parm, sequence f)
	c_proc(cgSetParameter2fC, parm&f)
end procedure


global procedure cgSetParameter2i(atom parm, sequence i)
	c_proc(cgSetParameter2iC, parm&i)
end procedure


global procedure cgSetParameter3d(atom parm, sequence d)
	c_proc(cgSetParameter3dC, parm&d)
end procedure


global procedure cgSetParameter3f(atom parm, sequence f)
	c_proc(cgSetParameter3fC, parm&f)
end procedure


global procedure cgSetParameter3i(atom parm, sequence i)
	c_proc(cgSetParameter3iC, parm&i)
end procedure

-------------------------------------------------------------------------------------------------------------------------------------


global function cgD3D9BindProgram(atom pgm)
	return c_func(cgD3D9BindProgramC, {pgm})
end function


global function cgD3D9IsProgramLoaded(atom pgm)
	return c_func(cgD3D9IsProgramLoadedC, {pgm})
end function


global function cgD3D9LoadProgram(atom pgm, integer parmShdw, atom asmFlags)
	return c_func(cgD3D9LoadProgramC, {pgm, parmShdw, asmFlags})
end function


global function cgD3D9GetLatestPixelProfile()
	return c_func(cgD3D9GetLatestPixelProfileC, {})
end function


global function cgD3D9GetLatestVertexProfile()
	return c_func(cgD3D9GetLatestVertexProfileC, {})
end function


global function cgD3D9GetOptimalOptions(integer pfl)
	return c_func(cgD3D9GetOptimalOptionsC, {pfl})
end function


global function cgD3D9SetDevice(atom dev)
	return c_func(cgD3D9SetDeviceC, {dev})
end function


global function cgD3D9SetTexture(atom parm, atom tex)
	return c_func(cgD3D9SetTextureC, {parm, tex})
end function


global function cgD3D9SetTextureParameter(atom parm, atom tex)
	return c_func(cgD3D9SetTextureParameterC, {parm, tex})
end function

-------------------------------------------------------------------------------------------------------------------------------------


global procedure cgGLBindProgram(atom pgm)
	c_proc(cgGLBindProgramC, {pgm})
end procedure


global procedure cgGLDisableProfile(integer pfl)
	c_proc(cgGLDisableProfileC, {pfl})
end procedure


global procedure cgGLEnableProfile(integer pfl)
	c_proc(cgGLEnableProfileC, {pfl})
end procedure


global function cgGLGetLatestProfile(integer pfl)
	return c_func(cgGLGetLatestProfileC, {pfl})
end function


global procedure cgGLLoadProgram(integer pgm)
	c_proc(cgGLLoadProgramC, {pgm})
end procedure


global procedure cgGLSetDebugMode(integer enable)
	c_proc(cgGLSetDebugModeC, {enable})
end procedure


global procedure cgGLSetOptimalOptions(integer pfl)
	c_proc(cgGLSetOptimalOptionsC, {pfl})
end procedure



